﻿using UnityEngine;
using System.Collections;

public class FollowingCamera : MonoBehaviour {

	public Transform target;
	public float smooth= 10.0f;
	public Vector3 Offset;
	public Vector3 TargetOffset;
	public Camera IceCamera;
	public Camera SpaceCamera;

	public bool NoInterpolate;

	Vector3 OldUpVector;
	Vector3 OldTargetLocation;

	// Use this for initialization
	void Start () {
		OldUpVector = Vector3.up;
	}

	void FixedUpdate () {

		float DeltaTime = Time.fixedDeltaTime;

		bool IsInSpace = (MainMng.Instance != null) ? MainMng.Instance.IsInSpace : false;

		if (IsInSpace) {
			IceCamera.enabled = false;
			SpaceCamera.enabled = true;
		} else {
			IceCamera.enabled = true;
			SpaceCamera.enabled = false;
		}

		Vector3 LocalOffset = target.TransformDirection (Offset);
		Vector3 TargetLocalOffset = target.TransformDirection (TargetOffset);

		if (NoInterpolate) {
			OldTargetLocation = target.transform.position + TargetLocalOffset;
			transform.position = target.position + LocalOffset;
			OldUpVector = target.transform.up;
			NoInterpolate = false;
		}

		OldTargetLocation = Vector3.Lerp (
			OldTargetLocation, target.transform.position + TargetLocalOffset,
			DeltaTime * smooth);

		transform.position = Vector3.Lerp (
			transform.position, target.position + LocalOffset,
			DeltaTime * smooth);

		OldUpVector = Vector3.Normalize (Vector3.Slerp (OldUpVector, target.transform.up, DeltaTime * 1.0f));

		transform.LookAt (OldTargetLocation, OldUpVector);

	}
}
