﻿using UnityEngine;
using System.Collections;

public class MainMng : MonoBehaviour
{
	// Public field, set in the inspector we can access
	// the audio clip through the singleton instance
	public Checkpoint CurrentCheckpoint;
	public int CurrentLap;
	public int CheckpointNumber;
	public int FinishCheckpoint;

	public StartingPoint Start;
	public Portal NextPortal;

	public bool IsInSpace;
	public bool NeedKill;
	
	// Static singleton property
	public static MainMng Instance { get; private set; }
	
	void Awake()
	{
		// First we check if there are any other instances conflicting
		if(Instance != null && Instance != this)
		{
			// If that is the case, we destroy other instances
			Destroy(gameObject);
		}

		CurrentLap = 0;
		CheckpointNumber = 0;
		CurrentCheckpoint = null;
		IsInSpace = false;
		FinishCheckpoint = 0;
		
		// Here we save our singleton instance
		Instance = this;
		
		// Furthermore we make sure that we don't destroy between scenes (this is optional)
		//DontDestroyOnLoad(gameObject);
	}
	
	// Instance method, this method can be accesed through the singleton instance
	/*public void PlayAudio(AudioClip clip)
	{
		audio.clip = clip;
		audio.Play();
	}*/
}
